<template>
  <div class="fr-col-12 fr-col-lg-5 fr-col-offset-lg-7 main-container fr-p-2w">
    <h2 class="fr-text--lg fr-mb-1w">Notifications</h2>
    <hr class="notification-separator" />
    <AtomAlert
      v-if="error"
      :alert-type="AlertType.Error"
      message="Les notifications n'ont pas pu être chargées."
    />
    <AtomFilters
      v-else-if="notifications?.length || filters"
      :filters="NOTIFICATION_FILTERS"
      full-width-filters
      @filter="onFilter"
    />
    <AtomLoader
      v-if="pending"
      class="fr-mx-auto"
    />
    <template v-else-if="notifications">
      <ul
        v-if="notifications.length"
        class="notification-list fr-mb-2w"
      >
        <NotificationItem
          v-for="notification in notifications"
          :key="notification.id"
          :notification="notification"
          @toggle-read="onNotificationToggleRead(notification.id)"
        />
      </ul>
      <p
        v-else
        class="fr-mb-2w no-notification-text"
      >
        Aucune notification
      </p>
      <hr class="notification-separator" />
      <button
        class="fr-btn fr-btn--sm fr-btn--tertiary toggle-read-notifications-btn"
        @click="onToggleReadNotifications"
      >
        {{ toggleReadNotificationsBtnLabel }}
      </button>
    </template>
  </div>
</template>

<script setup>
  import { AlertType } from '~~/utils/constants/alert'
  import { getRandomId } from '~~/utils/random'
  import { NOTIFICATION_TYPE_OPTIONS } from '~/utils/constants/notifications'
  import { withEmptyValue } from '~~/utils'

  const NOTIFICATION_FILTERS = [
    {
      name: 'type',
      label: 'Type',
      options: withEmptyValue(NOTIFICATION_TYPE_OPTIONS, 'Tous les types')
    }
  ]

  const { $getItems } = useNuxtApp()

  const {
    data: notifications,
    error,
    pending,
    refresh: notificationsRefresh
  } = useLazyAsyncData(getRandomId('notifications'), loadNotifications, {
    server: false
  })

  const filters = ref(null)
  const showReadNotifications = ref(false)

  const toggleReadNotificationsBtnLabel = computed(() =>
    showReadNotifications.value
      ? 'Voir les notifications non lues'
      : 'Voir les notifications déjà lues'
  )

  watch(filters, notificationsRefresh)

  async function loadNotifications() {
    const query = {
      sort: [{ field: 'date_created', sort: '-' }],
      filter: { read: { _eq: showReadNotifications.value } },
      fields: [
        '*',
        'item.*',
        'item.item.id',
        'item.item.beneficiary.id',
        'item.item.beneficiary.firstname',
        'item.item.beneficiary.usual_name',
        'item.item.beneficiary.birth_name',

        /**
         * As Agent d'accueil does not have access to all fields within
         * help_requests and follow_ups, accessing to the filename_download
         * field (that does not exists) raises a forbidden access error. By
         * providing the collection name, it properly scopes the field
         */
        'item.item:directus_files.filename_download'
      ]
    }

    if (filters.value) query.filter = { ...filters.value, ...query.filter }

    const res = await $getItems('notifications', query)

    if (res.status === 200) {
      return res.data.data.filter(
        notification => notification.item.length && notification.item[0].item
      )
    }
    throw new Error(errorResponseMessage(res))
  }

  function onFilter(_filters) {
    filters.value = _filters
  }

  function onNotificationToggleRead(notificationId) {
    notifications.value = notifications.value.filter(
      ({ id }) => id !== notificationId
    )
  }

  function onToggleReadNotifications() {
    showReadNotifications.value = !showReadNotifications.value
    notificationsRefresh()
  }
</script>

<style scope>
  .notification-list {
    --ul-start: 0;
    --xl-block: 0;
    --ul-type: none;
  }

  .notification-list > *:not(:last-child) {
    margin-bottom: 0.75rem;
  }

  .no-notification-text {
    color: var(--text-mention-grey);
    text-align: center;
  }

  .notification-separator {
    --text-spacing: 0 0 0.5rem;
  }

  .toggle-read-notifications-btn {
    margin: 0 auto;
    display: block;
  }
</style>
